//
//  MembershipListPresenter.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/21/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import Foundation
import RxSwift
import RxCocoa
import Action
import Resolver

enum MembershipEditingStyle {
    case create
    case edit(membership: Membership)
}
enum MembershipListNavigationOption {
    case membershipEditting(style: MembershipEditingStyle)
    case membershipProfile(membership: Membership)
}

protocol MembershipListWireframeInterface: WireframeInterface {
    func navigate(to option: MembershipListNavigationOption)
}

protocol MembershipListViewInterface: ViewInterface {
    var viewModels: BehaviorRelay<[MembershipItemViewModel]> { get }
}

final class MembershipListPresenter: MembershipListPresenterInterface {
    
    @LazyInjected var logger: Loggable
    
    let viewWillAppearTrigger = BehaviorRelay<Bool>(value: false)
    let selectedModelTrigger = PublishRelay<Membership>()
    let addMembershipTrigger = PublishRelay<Void>()
    
    // MARK: - Private properties -
    private lazy var getMembershipsAction = makgeGetMembershipsAction()
    private let disposeBag = DisposeBag()
    
    private unowned let view: MembershipListViewInterface
    private let interactor: MembershipListInteractorInterface
    private let wireframe: MembershipListWireframeInterface
    
    // MARK: - Lifecycle -
    
    init(view: MembershipListViewInterface,
         interactor: MembershipListInteractorInterface,
         wireframe: MembershipListWireframeInterface) {
        
        self.view = view
        self.interactor = interactor
        self.wireframe = wireframe
        
        configurePresenter()
        configureViewActions()
    }
}

// MARK: - Extensions -

extension MembershipListPresenter {
    private func configurePresenter() {
        getMembershipsAction
            .elements
            .map { memberships -> [MembershipItemViewModel] in
                return memberships.map { MembershipItemViewModel(model: $0) }
            }
            .bind(to: view.viewModels)
            .disposed(by: disposeBag)
        
        viewWillAppearTrigger
            .filter { $0 }
            .subscribeNext { [weak self] _ in
                self?.getMembershipsAction.execute()
            }
            .disposed(by: disposeBag)
    }
}

extension MembershipListPresenter {
    
    private func configureViewActions() {
        addMembershipTrigger
            .subscribeNext { [weak wireframe] in
                wireframe?.navigate(to: .membershipEditting(style: .create))
            }
            .disposed(by: disposeBag)
        
        selectedModelTrigger
            .subscribeNext { [weak wireframe] membership in
                wireframe?.navigate(to: .membershipProfile(membership: membership))
            }
            .disposed(by: disposeBag)
    }
}

extension MembershipListPresenter {
    func makgeGetMembershipsAction() -> Action<Void, [Membership]> {
        return Action<Void, [Membership]> { [unowned self] in
            return self.interactor.getMemberships()
        }
    }
}
